/*
 * Graphic lambda calculus in WebGL. This is a clone of the "GCalc" program
 * included in the "plt-games" package from the Racket Scheme distribution.
 * The original GCalc program was written by Eli Barzilay.
 *
 * Copyright (c) 2017 Pim Goossens
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

"use strict";

const MEMGRID_WIDTH = 5;
const MEMGRID_HEIGHT = 8;
const MEMGRID_SIZE = MEMGRID_WIDTH * MEMGRID_HEIGHT;

// GCalc expression storage array.
//   mem[i] = [expr, elemID]
var mem = new Array(MEMGRID_SIZE);

// Map from memcell element ID to array index.
var memcells = {};

function initmemory()
{
	var cellwidthspec = 80.0 / MEMGRID_WIDTH + "%";
	var cellheightspec = 80.0 / MEMGRID_HEIGHT + "%";

	for (var i=0; i<MEMGRID_SIZE; i++)
	{
		var cell = document.createElement("canvas");

		cell.id = "cell" + i;
		cell.className = "memcell";

		cell.style.width = cellwidthspec;
		cell.style.height = cellheightspec;

		var cs = window.getComputedStyle(cell);
		cell.width = parseInt(cs.width);
		cell.height = parseInt(cs.height);

		elements.memory.appendChild(cell);
		mem[i] = [null, cell.id];
		memcells[cell.id] = i;
	}
}
