/*
 * Graphic lambda calculus in WebGL. This is a clone of the "GCalc" program
 * included in the "plt-games" package from the Racket Scheme distribution.
 * The original GCalc program was written by Eli Barzilay.
 *
 * Copyright (c) 2017 Pim Goossens
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

"use strict";

var downx;
var downy;
var down;

function canvasdown(e)
{
	// If a second button is pressed, cancel the rotation.
	if (down)
	{
		setaddedrotation(0, 0);
		down = false;
		return;
	}

	// Left drags, right rotates. Disable the other buttons.
	if (e.button == 0)
	{
		return;
	}
	else if (e.button != 2)
	{
		e.preventDefault();
		return;
	}

	// TODO: other buttons for other functions?

	downx = e.clientX;
	downy = e.clientY;
	down = true;
}

function canvasup(e)
{
	storerotation();
	down = false;
}

function canvasmove(e)
{
	if (!down)
		return;

	if (e.buttons == 0)
	{
		canvasup(e);
		return;
	}

	var dx = e.clientX - downx;
	var dy = e.clientY - downy;

	setaddedrotation(dx, dy);
}

function canvasout(e)
{
	canvasup(e);
}

function inarea(x, y, x1, y1, x2, y2)
{
	return x >= x1 && y >= y1 && x <= x2 && y <= y2;
}

// Disable context menu for canvas except at the edge (5% margin).
function canvascontext(e)
{
	var x = e.clientX - canvasleft;
	var y = e.clientY - canvastop;
	var cw = canvaswidth;
	var ch = canvasheight;

	if (inarea(x, y, .05*cw, .05*ch, .95*cw, .95*ch))
		e.preventDefault();
}
